--- old/usr/src/lib/libc/port/locale/mskanji.c	Fri Jul 11 11:43:00 2014
+++ new/usr/src/lib/libc/port/locale/mskanji.c	Fri Jul 11 11:43:00 2014
@@ -1,4 +1,5 @@
 /*
+ * Copyright 2013 Garrett D'Amore <garrett@damore.org>
  * Copyright 2010 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2002-2004 Tim J. Robbins. All rights reserved.
  *
@@ -37,11 +38,11 @@
 #include "lint.h"
 #include <sys/types.h>
 #include <errno.h>
-#include "runetype.h"
 #include <stdlib.h>
 #include <string.h>
 #include <wchar.h>
 #include "mblocal.h"
+#include "lctype.h"
 
 static size_t	_MSKanji_mbrtowc(wchar_t *_RESTRICT_KYWD,
 		    const char *_RESTRICT_KYWD,
@@ -49,22 +50,28 @@
 static int	_MSKanji_mbsinit(const mbstate_t *);
 static size_t	_MSKanji_wcrtomb(char *_RESTRICT_KYWD, wchar_t,
 		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_MSKanji_mbsnrtowcs(wchar_t *_RESTRICT_KYWD,
+		    const char **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
+static size_t	_MSKanji_wcsnrtombs(char *_RESTRICT_KYWD,
+		    const wchar_t **_RESTRICT_KYWD, size_t, size_t,
+		    mbstate_t *_RESTRICT_KYWD);
 
 typedef struct {
 	wchar_t	ch;
 } _MSKanjiState;
 
-int
-_MSKanji_init(_RuneLocale *rl)
+void
+_MSKanji_init(struct lc_ctype *lct)
 {
 
-	__mbrtowc = _MSKanji_mbrtowc;
-	__wcrtomb = _MSKanji_wcrtomb;
-	__mbsinit = _MSKanji_mbsinit;
-	_CurrentRuneLocale = rl;
-	__ctype[520] = 2;
-	charset_is_ascii = 0;
-	return (0);
+	lct->lc_mbrtowc = _MSKanji_mbrtowc;
+	lct->lc_wcrtomb = _MSKanji_wcrtomb;
+	lct->lc_mbsnrtowcs = _MSKanji_mbsnrtowcs;
+	lct->lc_wcsnrtombs = _MSKanji_wcsnrtombs;
+	lct->lc_mbsinit = _MSKanji_mbsinit;
+	lct->lc_max_mblen = 2;
+	lct->lc_is_ascii = 0;
 }
 
 static int
@@ -153,4 +160,20 @@
 	for (i = len; i-- > 0; )
 		*s++ = wc >> (i << 3);
 	return (len);
+}
+
+static size_t
+_MSKanji_mbsnrtowcs(wchar_t *_RESTRICT_KYWD dst,
+    const char **_RESTRICT_KYWD src, size_t nms,
+    size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__mbsnrtowcs_std(dst, src, nms, len, ps, _MSKanji_mbrtowc));
+}
+
+static size_t
+_MSKanji_wcsnrtombs(char *_RESTRICT_KYWD dst,
+    const wchar_t **_RESTRICT_KYWD src, size_t nwc,
+    size_t len, mbstate_t *_RESTRICT_KYWD ps)
+{
+	return (__wcsnrtombs_std(dst, src, nwc, len, ps, _MSKanji_wcrtomb));
 }
